#ifndef HISTORYINFOLOAD_H
#define HISTORYINFOLOAD_H

#include <QObject>
#include <QMetaType>


struct HistoryInfo {
    bool isEdit = false;
    QString filepath = "";
    QString historytime = "";
    QString coverpath = "";
    QString themecnname = "";
    QString themename = "";
    QString themebuilder = "";
    QString thememail = "";
    QString themetype = "";
    QString wallpaperpath = "";
    QString accentcolor = "";
    QString widgetstyle = "";
    int radius = 6;
    int transparency = 65;
    int windowradius = 6;
};

Q_DECLARE_METATYPE(HistoryInfo)
class HistoryInfoLoad : public QObject {
    Q_OBJECT
public:


    explicit HistoryInfoLoad(const QString& date, QObject* parent = nullptr);
    QString getCover();
    QString getThemeCNName();
    QString getThemeName();
    QString getThemeBuilder();
    QString getThemeMail();
    QString getThemeType();
    void getRadius();
    void getWallpaper();
    void getAccentColor();
    void getTransparency();
    void getWidgetStyle();
    void getWindowRadius();
    HistoryInfo getInfoData();
    void updateHistoryInfo();
signals:

private:
    HistoryInfo m_historyInfo;
};

#endif // HISTORYINFOLOAD_H
