#ifndef GRUBTHEMEWIDGET_H
#define GRUBTHEMEWIDGET_H

#include "grubthemefeature.h"
#include "historywidget.h"
#include "basewidget.h"

#include <QObject>
#include <QWidget>
#include <QPushButton>
#include <QVBoxLayout>
#include <QScrollArea>
#include <QLabel>
#include <QCheckBox>

class GrubThemeWidget : public QWidget
{
    Q_OBJECT
public:
    explicit GrubThemeWidget(QWidget *parent = nullptr);
    void initPreviewWidget();
    void initRightWidget();
    void addspaceritem();
    void initEditWidget();
    static bool g_themeChange;
    void eidtInitWidget(const HistoryInfo &InfoData);
    void refresh();
signals:
    void newGrubFilePath(const QString& path);
private:
    const QString resourceGrubPath = ":/resource/background/grub-background.png";
    BasePreviewWidget *m_previewwidget;
    GrubImageWidget *m_preview;
    QWidget *m_rightwidget;
    QWidget *m_grubwidget;
    QVBoxLayout *m_previewlayout;
    GrubEditButton *m_showBtn;
};

#endif // GRUBTHEMEWIDGET_H
