#ifndef PLYMOUTHMOUTHTHEMEWIDGET_H
#define PLYMOUTHMOUTHTHEMEWIDGET_H
#include "plymouththemefeature.h"
#include "iconwidgetfeature.h"
#include "historywidget.h"
#include "basewidget.h"
#include "../fileProcess/filecheck.h"

#include <QObject>
#include <QWidget>
#include <QPushButton>
#include <QVBoxLayout>
#include <QLabel>
#include <QCheckBox>
#include <QButtonGroup>

class PlymouthThemeWidget : public QWidget
{
    Q_OBJECT
public:
    explicit PlymouthThemeWidget(QWidget *parent = nullptr);
    void initPreviewWidget();
    void initRightWidget();
    void addspaceritem();
    void initEditWidget();
    void setThumbnailIcon(QString path);
    static bool g_themeChange;
    void startShowPlymouth();
    void eidtInitWidget(const HistoryInfo &InfoData);
    void refresh();
signals:
    void newPlymouthFilePath(const QString& path);
    void refreshPlymouthDir();
private:
    BasePreviewWidget *m_previewwidget;
    PlymouthImageWidget *m_preview;
    QWidget *m_rightwidget;
    QWidget *m_plymouthwidget;
    QVBoxLayout *m_previewlayout;
    PlymouthCustomLabel *m_customLabel;
    QString m_imagedirpath;
};

#endif // PLYMOUTHMOUTHTHEMEWIDGET_H
